<script setup lang="tsx">
import { reactive, ref, unref } from 'vue'
import {
  getRepTemplateListApi,
  saveRepTemplateApi,
  delRepTemplateListApi,
  delRepTemplateApi,
  exportTemplateApi,
  queryRepTemplateApi,
  getCategory,
} from '@/api/reporting/RepTemplate/RepTemplate'
import { TableData } from '@/api/reporting/RepTemplate/RepTemplate/types'
import { useTable } from '@/hooks/web/useTable'
import { useI18n } from '@/hooks/web/useI18n'
import { Table, TableColumn } from '@/components/Table'
import { ElButton, ElLink, ElLoading, ElPopconfirm, ElMessage, ElTag, colProps } from 'element-plus'
import { Search } from '@/components/Search'
import { FormSchema } from '@/components/Form'
import { ContentWrap } from '@/components/ContentWrap'
import Write from './components/Write.vue'
import { Dialog } from '@/components/Dialog'
import { getWidth, transfDictList } from '@/utils';
import Detail from './components/Detail.vue'
import { REPORTING_STATUS_LIST } from './constants'
import { useRouter } from 'vue-router';

const router = useRouter()
const { t } = useI18n()

const ids = ref<string[]>([])

const { tableRegister, tableState, tableMethods } = useTable({
  fetchDataApi: async () => {
    const { currentPage, pageSize } = tableState
    const res = await getRepTemplateListApi({
      pageIndex: unref(currentPage),
      pageSize: unref(pageSize),
      ...unref(searchParams)
    })
    return {
      list: res.body.list,
      total: res.body.total
    }
  },
  fetchDelApi: async () => {
    const res = await delRepTemplateListApi(unref(ids));
    return !!res;
  },
})

/** 导出Excel */
const exportExcel = async () => {
  const data = { ...unref(searchParams) }
  await exportTemplateApi(data)
}

const { loading, dataList, total, currentPage, pageSize } = tableState
const { getList, getElTableExpose, delList, refresh } = tableMethods

const tableColumns = reactive<TableColumn[]>([
  {
    field: 'selection',
    type: 'selection',
    fixed: true
  },
  {
    field: 'tName',
    label: '名称',
    width: 160,
  },
  {
    field: 'tCategory',
    label: '报告分类',
  },
  {
    field: 'createUser',
    label: '编写人'
  },
  {
    field: 'uploadUser',
    label: '上传人'
  },
  {
    field: 'tVersion',
    label: '版本'
  },
  {
    field: 'createTime',
    label: '上传时间',
    width: 150,
  },
  {
    field: 'updateTime',
    label: '修改时间',
    width: 160,
  },
  {
    field: 'tDescription',
    label: '描述'
  },
  {
    field: 'tStatus',
    label: '状态',
    formatter:(row:Recordable,_:TableColumn) =>{
      const state=REPORTING_STATUS_LIST.find((item)=>item.value===row.tStatus)
      if(state&&state.value =='1'){
          return <ElTag type="primary">{state.label}</ElTag>
      }
      else{
        return <ElTag type="info">停用</ElTag>
      }
    }
  },
  {
    field: 'action',
    label: t('tableDemo.action'),
    width: 160,
    fixed: 'right',
    slots: {
      default: (data: any) => {
        return (
          <>
            <ElLink type="primary" underline={false} onClick={() => action(data.row, 'edit')}>
              {t('tableDemo.edit')}
            </ElLink>
            <ElPopconfirm
              title={t('common.delTableMsg')}
              width={200}
              v-slots={{
                reference: () => {
                  return (
                    <>
                      <ElLink type="primary" underline={false}>
                        {t('tableDemo.del')}
                      </ElLink>
                    </>
                  )
                }
              }}
              onConfirm={() => delData(data.row)}
            ></ElPopconfirm>
            
          </>
        )
      }
    }
  }
].map(item => ({ minWidth: item.label ? getWidth(item.label) : 120, ...item }) as TableColumn))

const searchSchema = reactive<FormSchema[]>([
  {
    field: 'tCategory',
    label: '报告分类',
    component: 'Select',
    optionApi: async () => {
        const res = await getCategory({ paramName: 'reportingType_param', systemCode: 'ordb' });
        return transfDictList(res.body.result);
      },
      value: '1'
  },
  {
    field: 'createUser',
    label: '编写人',
    componentProps: {},
    component: 'Input'
  },
  {
    field: 'tName',
    label: '名称',
    componentProps: {},
    component: 'Input'
  },
  {
    field: 'createTime',
    label: '上传时间',
    componentProps: {type: 'daterange'},
    component: 'DatePicker'
  }
])
const searchParams = ref({})
const setSearchParams = (data: any) => {
  searchParams.value = data
  getList()
}

const dialogVisible = ref(false)
const dialogTitle = ref('')

const currentRow = ref()
const actionType = ref('')

const writeRef = ref<ComponentRef<typeof Write>>()

/**单行查询**/
const action = async (row: TableData, type: string) => {
  let detailLoading = ElLoading.service({
    background: 'rgba(0, 0, 0, 0.7)'
  })
  const res = await queryRepTemplateApi(row.tId)
    .catch(() => {})
    .finally(() => {
      detailLoading.close()
    })
  detailLoading.close()
  if (res) {
    const data = res.body.result
    dialogTitle.value = t(type === 'edit' ? 'tableDemo.edit' : 'tableDemo.detail')
    actionType.value = type
    currentRow.value = data
    dialogVisible.value = true
  }
}

const AddAction = () => {
  dialogTitle.value = "上传模板";
  currentRow.value = undefined
  dialogVisible.value = true
  actionType.value = 'add'
}
const saveLoading = ref(false)

/** 保存 **/
const save = async () => {
  const write = unref(writeRef)
  const formData = await write?.submit()
  if (formData) {
    saveLoading.value = true
    const res = await saveRepTemplateApi(formData)
      .catch(() => {})
      .finally(() => {
        saveLoading.value = false
      })
    if (res) {
      dialogVisible.value = false
      currentPage.value = 1
      getList()
    }
  }
}

const delLoading = ref(false)

/** 批量删除  **/
const delDataBatch = async () => {
  const elTableExpose = await getElTableExpose()
  ids.value = elTableExpose?.getSelectionRows().map((v: TableData) => { v.tId }) || []
  delLoading.value = true
  await delList(unref(ids).length).finally(() => {
    delLoading.value = false
  })
}

/** 单行删除 */
const delData = async (row: TableData) => {
  const res = await delRepTemplateApi(row.tId)
  if (res) {
    const { code, errMsg } = res.head
    if (code === '0') {
      ElMessage.success('删除成功!')
      getList()
    } else {
      ElMessage.error(errMsg || '删除失败!')
    }
  }
}

const disabled = ref(true)

const onSelectionChange = (selection: TableData[]) => {
  disabled.value = selection.length === 0
}
</script>

<template>
  <ContentWrap>
    <Search :schema="searchSchema" @reset="setSearchParams" @search="setSearchParams" />

    <Table
      :columns="tableColumns"
      v-model:pageSize="pageSize"
      v-model:currentPage="currentPage"
      default-expand-all
      node-key="tId"
      :data="dataList"
      :loading="loading"
      :pagination="{
        total
      }"
      @selection-change="onSelectionChange"
      @register="tableRegister"
      @refresh="refresh"
    >
      <template #buttons>
        <ElButton type="primary" @click="AddAction">{{ t('tableDemo.add') }}</ElButton>
      </template>
    </Table>
  </ContentWrap>

  <Dialog v-model="dialogVisible" :title="dialogTitle">
    <Write
      v-if="actionType !== 'detail'"
      ref="writeRef"
      :current-row="currentRow"
      :action-type="actionType"
    />
    <Detail v-if="actionType === 'detail'" :current-row="currentRow" />
    <template #footer>
      <ElButton v-if="actionType !== 'detail'" type="primary" :loading="saveLoading" @click="save">
        {{ t('dialogDemo.save') }}
      </ElButton>
      <ElButton @click="dialogVisible = false">{{ t('dialogDemo.close') }}</ElButton>
    </template>
  </Dialog>
</template>